



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>基于swift语言iOS8的蓝牙连接（初步）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">基于swift语言iOS8的蓝牙连接（初步）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-11 14:52:31 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>　　看过一些蓝牙App的事例，大体上对蓝牙的连接过程进行了了解。但是开始真正自己写一个小的BLE程序的时候就举步维艰了。那些模棱两可的概念在头脑中瞬间就蒸发了，所以还是决定从最基本的蓝牙连接过程进行。这里所说的蓝牙是针对 bluetooth 4.0的。</p>
<p>　　第一步就是去看官方的关于蓝牙框架的文档，即<strong>Core Bluetooth Programming Guide</strong><strong>，</strong>在苹果的官方网站上可以轻松找到，不管你对蓝牙的基本概念是否有了解，这个文件可以使你更好的对蓝牙的连接过程有个了解。这个文档的前面几张介绍了关于bluetooth 4.0开发过程中必要的概念（这些概念必不可少，一定要搞懂，否则后面会搞得很乱），真正开始将连接过程是从<strong>Performing Common Central Role Tasks&nbsp;</strong>这一章开始，这里很清晰的将过程分成了以下这么几步，每一步对有对应的接口函数，只需要按着这一步一步写下去就可以。</p>
<div>
<div>
<div>
<ul><li>Start up a central manager object</li>
<li>Discover and connect to peripheral devices that are advertising</li>
<li>Explore the data on a peripheral device after you&rsquo;ve connected to it</li>
<li>Send read and write requests to a characteristic value of a peripheral&rsquo;s service</li>
<li>Subscribe to a characteristic&rsquo;s value to be notified when it is updated</li></ul>
<p>　　针对每一步我将我的Swift所对应的代码列出来：</p>
<div>
<div>
<div>
<p>Starting Up a Central Manager</p>
<p>将CBCenteralManager实例化，如下：</p>
<div>
<pre class="prettyprint linenums">     //start up a central manager object<br />
     func startCentralManager(){<br />
         myCentralManager = CBCentralManager(delegate: self, queue: nil)<br />
     }</pre>
</div>
<p>当实例化成功后，对调用如下函数：</p>
<div>
<pre class="prettyprint linenums">     func centralManagerDidUpdateState(central: CBCentralManager!){<br />
         println("CentralManager is initialized")

         switch central.state{<br />
         case CBCentralManagerState.Unauthorized:<br />
             println("The app is not authorized to use Bluetooth low energy.")<br />
         case CBCentralManagerState.PoweredOff:<br />
             println("Bluetooth is currently powered off.")<br />
         case CBCentralManagerState.PoweredOn:<br />
             println("Bluetooth is currently powered on and available to use.")<br />
         default:break<br />
         }<br />
     }</pre>
</div>
<p>此时CBCenteralManager实例化完毕，就可以开始进行扫描外设了。</p>
<p>2、Discovering Peripheral Devices That Are Advertising</p>
<p>OC中扫描函数是：</p>
<div>
<pre class="prettyprint linenums"> [myCentralManager scanForPeripheralsWithServices:nil options:nil];</pre>
</div>
<p>在swift中对应的是：</p>
<div>
<pre class="prettyprint linenums"> myCentralManager!.scanForPeripheralsWithServices(nil , options: nil)</pre>
</div>
<p>当发现设备后，会调用如下的函数,这样我们就可以对设备进行一定的操作，当发现设备后接下来应该是连接设备。</p>
<div>
<pre class="prettyprint linenums">     func centralManager(central: CBCentralManager!, didDiscoverPeripheral peripheral: CBPeripheral!, advertisementData: [NSObject : AnyObject]!, RSSI: NSNumber!) {<br />
         println("CenCentalManagerDelegate didDiscoverPeripheral")<br />
         println("Discovered \(peripheral.name)")<br />
         println("Rssi: \(RSSI)")

         println("Stop scan the Ble Devices")<br />
         myCentralManager!.stopScan()<br />
         cbPeripheral = peripheral

     }</pre>
</div>
<p>3、Connecting to a Peripheral Device After You&rsquo;ve Discovered It</p>
<p>OC中连接设备的代码是：</p>
<div>
<pre class="prettyprint linenums"> [myCentralManager connectPeripheral:peripheral options:nil];</pre>
</div>
<p>Swift中的代码是：</p>
<div>
<pre class="prettyprint linenums"> myCentralManager!.connectPeripheral(cbPeripheral!, options: nil)</pre>
</div>
<p>连接的结果会调用下面三个回调函数</p>
<div>
<pre class="prettyprint linenums">     func centralManager(central: CBCentralManager!, didConnectPeripheral peripheral: CBPeripheral!) {<br />
         println("CenCentalManagerDelegate didConnectPeripheral")<br />
         println("Connected with \(peripheral.name)")<br />
         peripheral.delegate = self

         peripheral.discoverServices(nil)<br />
     }

     func centralManager(central: CBCentralManager!, didFailToConnectPeripheral peripheral: CBPeripheral!, error: NSError!) {<br />
         println("CenCentalManagerDelegate didFailToConnectPeripheral")<br />
     }

     func centralManager(central: CBCentralManager!, didDisconnectPeripheral peripheral: CBPeripheral!, error: NSError!) {<br />
         println("CenCentalManagerDelegate didDisconnectPeripheral")<br />
     }</pre>
</div>
<p>具体含义可以查询官方文档。</p>
<p>注意：连接设备的函数不能在didDiscoverPeripheral回调函数中直接调用，这样是无法连接的，这个问题也困扰了我一会，后面歪打正着就成了， 要么设一个延迟再去connect，要么加个按钮触发事件再去连接。</p>
<p>4、Discovering the Services of a Peripheral That You&rsquo;re Connected To</p>
<p>当连接完毕后，就是扫描这个外设（Peripheral）所支持服务。然后可以保存下来，下次可以直接调用</p>
<p>OC中扫描Services的代码如下：</p>
<div>
<pre class="prettyprint linenums"> ￼[peripheral discoverServices:nil];</pre>
</div>
<p>Swift中如下：</p>
<div>
<pre class="prettyprint linenums"> peripheral.discoverServices(nil)</pre>
</div>
<p>当扫描到Service后对调用下面的回调函数：</p>
<div>
<pre class="prettyprint linenums"> func peripheral(peripheral: CBPeripheral!, didDiscoverServices error: NSError!) {<br />
         println("CBPeripheralDelegate didDiscoverServices")<br />
         for  service in peripheral.services {<br />
             println("Discover service \(service)")<br />
             println("UUID \(service.UUID)")<br />
             if(service.UUID == CBUUID.UUIDWithString("")){<br />
                 println("Immediate_Alert_Service")<br />
                 immediateAlertService = (service as CBService)<br />
                 peripheral.discoverCharacteristics(nil , forService: immediateAlertService)<br />
             }else if(service.UUID == CBUUID.UUIDWithString("")){<br />
                 println("Link_Loss_Service")<br />
                 linkLossAlertService = (service as CBService)<br />
                 peripheral.discoverCharacteristics(nil , forService: linkLossAlertService)<br />
             }<br />
         }<br />
     }</pre>
</div>
<p>扫描到Service后，要遍历这个Service所包含的Characteristics。</p>
<p>5、Discovering the Characteristics of a Service</p>
<p>扫描Characteristics</p>
<div>
<pre class="prettyprint linenums">  peripheral.discoverCharacteristics(nil , forService: linkLossAlertService)</pre>
</div>
<p>和扫描Services一样，会有回调函数</p>
<div>
<pre class="prettyprint linenums"> func peripheral(peripheral: CBPeripheral!, didDiscoverCharacteristicsForService service: CBService!, error: NSError!) {<br />
         for characteristic in service.characteristics{

             if(service == immediateAlertService &amp;&amp; characteristic.UUID == CBUUID.UUIDWithString("2A06")){<br />
                 println("immediateAlertService Discover characteristic \(characteristic)")<br />
                 alertLevelCharacteristic = (characteristic as CBCharacteristic)<br />
                 //immediateAlertCharacter 写入是有问题的<br />
 //                cbPeripheral!.writeValue(NSData(bytes: &amp;alertLevel, length: 1), forCharacteristic: characteristic as CBCharacteristic, type: CBCharacteristicWriteType.WithResponse)<br />
             }else if(service == linkLossAlertService &amp;&amp; characteristic.UUID == CBUUID.UUIDWithString("2A06")){<br />
                 println("linkLossAlertService Discover characteristic \(characteristic)")<br />
                 linkLossAlertCharacteristic = (characteristic as CBCharacteristic)<br />
                 //linkLossAlertCharacteristic 写入没有问题，所以通过这个写入来进行绑定<br />
                 cbPeripheral!.writeValue(NSData(bytes: &amp;alertLevel, length: ), forCharacteristic: characteristic as CBCharacteristic, type: CBCharacteristicWriteType.WithResponse)<br />
             }<br />
         }<br />
     }</pre>
</div>
<p>这样就把每个Service所对应的Characteristics给读取出来了。</p>
<p>6、Retrieving the Value of a Characteristic</p>
<div>
<div>
<div>
<ul><li>Reading the Value of a Characteristic</li></ul>
<div>
<pre class="prettyprint linenums"> cbPeripheral!.readValueForCharacteristic(alertLevelCharacteristic!)</pre>
</div>
<p>值在回调函数中获取，在read之前，要注意这个Characteristic是否可读。</p>
<div>
<pre class="prettyprint linenums">     func peripheral(peripheral: CBPeripheral!, didUpdateValueForCharacteristic characteristic: CBCharacteristic!, error: NSError!) {<br />
         if(error != nil){<br />
             println("Error Reading characteristic value: \(error.localizedDescription)")<br />
         }else{<br />
             var data = characteristic.value<br />
             println("Update value is \(data)")<br />
         }

     }</pre>
</div>
<div>
<div>
<div>
<ul><li>Writing the Value of a Characteristic</li></ul>
</div>
</div>
</div>
</div>
</div>
</div>
<div>
<pre class="prettyprint linenums"> var alertLevel:Byte = 0x02<br />
 cbPeripheral!.writeValue(NSData(bytes: &amp;alertLevel, length: ), forCharacteristic: alertLevelCharacteristic!, type: CBCharacteristicWriteType.WithoutResponse)</pre>
</div>
<p>写是否成功会根据CBCharacteristicWriteType来决定是否调用下面的回调函数：</p>
<div>
<pre class="prettyprint linenums"> func peripheral(peripheral: CBPeripheral!, didWriteValueForCharacteristic characteristic: CBCharacteristic!, error: NSError!) {<br />
         if(error != nil){<br />
             println("Error writing characteristic value: \(error.localizedDescription)")<br />
         }else{<br />
             println("Write value success!")<br />
         }

     }</pre>
</div>
<p>关于write我这里还有些注意的地方要强调！！！！</p>
<p>并不是每一个Characteristic都可以通过回调函数来查看它写入状态的。就比如针对&nbsp;immediateAlertService（1802） 的&nbsp;alertLevelCharacteristic（2A06），就是一个不能有response的Characteristic。刚开始我就一直用CBCharacteristicWriteType.WithResponse来进行写入始终不成功，郁闷坏了，最后看到每个Characteristic还有个属性值是指示这个的，我将每个Characteristic打印出来有如下信息：</p>
<div>
<pre class="prettyprint linenums">immediateAlertService Discover characteristic &lt;CBCharacteristic: 0x15574d00, UUID = 2A06, properties = 0x4, value = (null), notifying = NO&gt;<br />
linkLossAlertService Discover characteristic &lt;CBCharacteristic: 0x15671d00, UUID = 2A06, properties = 0xA, value = (null), notifying = NO&gt;</pre>
</div>
<p>这个的properties是什么刚开始不知道，觉得他没意义，后面才注意到properties是Characteristic的一个参数，具体解释如下：</p>
<div>
<pre class="prettyprint linenums">Declaration<br />
SWIFT<br />
struct CBCharacteristicProperties : RawOptionSetType {<br />
    init(_ value: UInt)<br />
    var value: UInt<br />
    static var Broadcast: CBCharacteristicProperties { get }<br />
    static var Read: CBCharacteristicProperties { get }<br />
    static var WriteWithoutResponse: CBCharacteristicProperties { get }<br />
    static var Write: CBCharacteristicProperties { get }<br />
    static var Notify: CBCharacteristicProperties { get }<br />
    static var Indicate: CBCharacteristicProperties { get }<br />
    static var AuthenticatedSignedWrites: CBCharacteristicProperties { get }<br />
    static var ExtendedProperties: CBCharacteristicProperties { get }<br />
    static var NotifyEncryptionRequired: CBCharacteristicProperties { get }<br />
    static var IndicateEncryptionRequired: CBCharacteristicProperties { get }<br />
}<br />
OBJECTIVE-C<br />
typedef enum {<br />
   CBCharacteristicPropertyBroadcast = 0x01,<br />
   CBCharacteristicPropertyRead = 0x02,<br />
   CBCharacteristicPropertyWriteWithoutResponse = 0x04,<br />
   CBCharacteristicPropertyWrite = 0x08,<br />
   CBCharacteristicPropertyNotify = 0x10,<br />
   CBCharacteristicPropertyIndicate = 0x20,<br />
   CBCharacteristicPropertyAuthenticatedSignedWrites = 0x40,<br />
   CBCharacteristicPropertyExtendedProperties = 0x80,<br />
   CBCharacteristicPropertyNotifyEncryptionRequired = 0x100,<br />
   CBCharacteristicPropertyIndicateEncryptionRequired = 0x200,<br />
} CBCharacteristicProperties;</pre>
</div>
</div>
</div>
</div>
<p>可以看到0x04对应的是CBCharacteristicPropertyWriteWithoutResponse</p>
<p>0x0A对应的是CBCharacteristicPropertyNotify</p>
<p>所以&nbsp;immediateAlertService（1802） 的&nbsp;alertLevelCharacteristic（2A06）是不能用CBCharacteristicWriteType.WithRespons进行写入，只能用CBCharacteristicWriteType.WithOutRespons。这样在以后的开发中可以对每个Characteristic的这个参数进行检查再进行设置。</p>
<p>最后讲一下关于蓝牙绑定的过程，在iOS中，没有讲当绑定的过程，直接就是扫描、连接、交互。从而很多人会认为，连接就是绑定了，其实不然。在iOS开发中，连接并没有完成绑定，在网上找到了个很好的解释：</p>
<blockquote><div>
<div>
<blockquote><div>
<blockquote><div>
<div>
<div>
<div>you cannot initiate pairing from the iOS central side. Instead, you have to read/write a characteristic value,</div>
<div>and then let your peripheral respond with an "Insufficient Authentication" error.</div>
<div>iOS will then initiate pairing, will store the keys for later use (bonding) and encrypts the link. As far as I know,</div>
<div>it also caches discovery information, so that future connections can be set up faster.</div>
</div>
</div>
</div></blockquote>
</div></blockquote>
</div>
</div></blockquote>
<p>就是当发生读写交互时，系统在会和外设进行绑定操作!!!</p>
</div>
</div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/1q2m1dv8.html">Maximo7自定义实现WebService</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jdnj09.html">【圣诞特献】Web 前端开发精华文章推荐【系列二十一】</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnlrr29.html">Python 3 与 MySQL 5&period;6</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2e2w3q.html">C&plus;&plus; list的基本操作和使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql0xokq.html">join用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqv6kry8.html">objc&lowbar;msgSend&lpar;&rpar;报错Too many arguments to function call &comma;expected 0&comma;have3</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvxzlj8.html">MySQL建立索引的注意事项</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oknvk19.html">Perl中的替换&lpar;七&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mmlrkq.html">Myeclipse优化篇</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xnzz68.html">asp&period;net&lowbar;MVC&lowbar;jq三级联动</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwd3xlz8.html">串口屏之------Usart GPU 使用手册</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gm25ge9.html">logstash grok 解析Nginx</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okx52l9.html">展开BOM并使用最终用量的算法&lpar;转载&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yr4vn8.html">编写CGI程序步骤</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7z1jxg9.html">RDO Stack Exception&colon; UnboundLocalError&colon; local variable &amp;&num;39&semi;logFile&amp;&num;39&semi; referenced before assignment</a>
		</li>
						<li><a href="https://www.batexi.com/a/950e5408.html">【Redis】LRU算法和Redis的LRU实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/95g01kvq.html">pycharm 有些模块没有提示  解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pww7ky8.html">Python开发端口扫描器</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rp1228.html">配置中文分词器 IK-Analyzer-Solr7</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwvnzz8.html">mysql 开发进阶篇系列 31 工具篇&lpar;mysql连接工具与MyISAM表压缩工具&rpar;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q7mem7jq.html">android 上传文件&amp;quot&semi;Content-Type&amp;quot&semi;&comma;为&amp;quot&semi;application&sol;octet-stream&amp;quot&semi;  用php程序在服务端用&dollar;GLOBALS&lbrack;&amp;&num;39&semi;HTTP&lowbar;RAW&lowbar;POST&lowbar;DATA&amp;&num;39&semi;&rsqb;接受（二）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pjpwo79.html">Oracle笔记 十四、查询XML操作、操作系统文件</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwdll4z8.html">Hbase多master</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxn2lkj8.html">移动端rem自适应布局关键代码</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvvedyyq.html">javaSE第二十天</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxn2e2j8.html">libevent和基于libevent的网络编程</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdejomx9.html">Windows系统错误代码大全</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2wk26xq.html">EasyUI datagrid checkbox数据设定与取值（转自http&colon;&sol;&sol;blog&period;csdn&period;net&sol;baronyang&sol;article&sol;dnetails&sol;9323463，感谢分享，谢谢）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gmpgd49.html">scala学习笔记1</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4yp6k0q.html">android属性</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
